SystemOrganization addCategory: #'EjerciciosPoo-Distance'!

Measurment subclass: #Distance
	instanceVariableNames: 'unit magnitud'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 20:45'!
* aNumber
|aResult|

aResult:= self copy.
^aResult  magnitud: aResult amount * aNumber .
"
^self  magnitud: self amount * aNumber .
"! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 13:36'!
+ aDistance 
|aResult|

aResult:= (self convertTo: aDistance unit).
^Distance new magnitud: aResult  amount + aDistance amount unit: aDistance unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 12:52'!
- aDistance
|aResult|

aResult:= (self convertTo: aDistance unit).
^Distance new magnitud: aResult  amount - aDistance amount unit: aDistance unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 13:09'!
/ aNumber
|aResult|

aResult:= self copy.
^aResult  magnitud: aResult amount / aNumber .! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 13:50'!
< aDistance
^((self convertTo: aDistance unit) amount < aDistance amount).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 13:54'!
<= aDistance
^((self convertTo: aDistance unit) amount <= aDistance amount).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 23:50'!
= aDistance 
(aDistance class == self class) ifFalse: [ ^false ]. " verifica que no entren otros objetos"
((aDistance unit) name = (self unit) name) ifTrue: [ ^(self magnitud = aDistance magnitud )].
^((self convertTo: aDistance unit ) magnitud  = aDistance  magnitud )  .
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 13:53'!
> aDistance
^((self convertTo: aDistance unit) amount > aDistance amount).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 13:54'!
>= aDistance
^((self convertTo: aDistance unit) amount >= aDistance amount).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 15:37'!
amount
^magnitud! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 14:04'!
between: aMinDistance and: aMaxDistance

^(self > aMinDistance & self < aMaxDistance) .

! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/9/2013 17:00'!
convert: aDistance 
" aca llega cuadno los objetos son de distintas clases
   por ahora metrs y centimetros"
(self isKindOf: Centimeter) ifFalse:  [ self magnitud: (self magnitud *100) ].
^self! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 19:01'!
convertTo: aUnit
| aMagnitud|
((self unit) name = aUnit  name) ifTrue: [ ^self ].
(aUnit factor < self unit factor) ifTrue: [aMagnitud := self magnitud * (  aUnit factor / (self unit factor)) ].
(aUnit factor > self unit factor) ifTrue: [aMagnitud := self magnitud / ( (self unit  factor) / aUnit factor) ].
^ Distance new  magnitud: (aMagnitud )  unit: aUnit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 17:29'!
convertToOneDistance 
^ Distance new magnitud:1 unit: self unit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 19:58'!
do: aBlock 
self perform aBlock .! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 18:23'!
equivalentTo: aDistance

^(self = (aDistance  convertTo: self unit) ).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'manfredoyMercedes 5/22/2013 14:01'!
identityHash
^(self convertTo: self  unit baseunit  ) amount ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'manfredoyMercedes 5/14/2013 23:08'!
magnitud
	
	^ magnitud! !

!Distance methodsFor: 'as yet unclassified' stamp: 'manfredoyMercedes 5/14/2013 23:03'!
magnitud: aSmallInteger 
	
	magnitud := aSmallInteger! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 14:43'!
magnitud: aMagnitud unit: aUnit.
	
	magnitud := aMagnitud.
	unit:= aUnit.! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 14:00'!
max: aDistance 

(self >= aDistance) ifTrue: [ ^ self. ].
^ aDistance.
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 14:00'!
min: aDistance 

(self <= aDistance) ifTrue: [ ^ self. ].
^ aDistance.
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 12:36'!
negated
|aDistance|
  aDistance := self copy.
^ aDistance magnitud: aDistance magnitud * (-1).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 23:25'!
oneMeter
^Distance new magnitud: 1 unit: Units new meter  ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 13:41'!
printString
	| plural digito|
	plural := ''.
	digito := ''.
	(self magnitud > 1)	ifTrue: [ plural := 's' ].
	 digito := self magnitud asString, ' '.
	^ (digito, self unit name asString onlyLetters , plural).! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/9/2013 17:55'!
printString: aDistance 
^aDistance printString .! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 18:10'!
to: aDistance
|anInterval|
anInterval := DistanceInterval new.
anInterval := anInterval from: self to: aDistance.
(self  convertToOneDistance < aDistance convertToOneDistance ) ifTrue: [ anInterval by: self convertToOneDistance.  ^anInterval . ].
anInterval by: aDistance convertToOneDistance .
^anInterval .

! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 18:12'!
to: aDistance by:  aDistanceBy
|anInterval|
anInterval := self to: aDistance.
anInterval  by: aDistanceBy.
^anInterval .
! !

!Distance methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 14:21'!
unit
 ^unit ! !

!Distance methodsFor: 'as yet unclassified' stamp: 'manfredoyMercedes 5/14/2013 23:04'!
unit: aDistanceUnit 
	
	unit := aDistanceUnit! !

Object subclass: #DistanceInterval
	instanceVariableNames: 'from to by units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 17:25'!
by  
^by ! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 17:26'!
by:  byADistance
^by:=  byADistance.! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 20:42'!
do: aBlock
| aDistance|
aDistance := Distance new.
aDistance := self from.
[( aDistance  <= self to  )] whileTrue: [ aBlock value: aDistance. aDistance:= aDistance  + self by].




! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 17:25'!
from 
^from! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 18:09'!
from: aDistanceFrom to: aDistanceTo 
from:= aDistanceFrom.
to:= aDistanceTo .
^self.! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 17:25'!
initialize 
units := Units new.
from := Distance new magnitud: 1 unit: units meter .
to:= from.
by := from.
! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 18:49'!
size 
|difference|
difference := (self from convertTo: self by unit) amount - (self to convertTo: self by unit) amount .
(difference < 0 ) ifTrue: [difference:= difference * (-1)].
^difference +1.
! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 17:25'!
to 
^to! !

MeasurmentUnit subclass: #DistanceUnit
	instanceVariableNames: 'name factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 14:19'!
factor	
^factor! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 14:20'!
factor: aFactor
	^ factor := aFactor! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 14:19'!
name 
^ name! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'manfredoyMercedes 5/14/2013 23:04'!
name: aByteString 
		name := aByteString! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 14:28'!
name: aByteString factor: aFactor
		name := aByteString.
		factor:= aFactor! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 15:29'!
printString
 ^ self name! !

DistanceUnit subclass: #Units
	instanceVariableNames: 'centimeter decameter decimeter hectometer kilometer meter millimeter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:24'!
centimeter
^centimeter! !

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:24'!
decameter
^decameter! !

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:24'!
decimeter
^decimeter! !

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:24'!
hectometer
^hectometer! !

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:26'!
initialize
millimeter := DistanceUnit new name: 'millimeter' factor: 1000.
centimeter:=DistanceUnit new name: 'centimeter' factor: 100.
decimeter:= DistanceUnit new name: 'decimeter' factor: 10.
meter:= DistanceUnit new name: 'meter' factor: 1.
decameter := DistanceUnit new name: 'decameter' factor: 1/10.
hectometer :=DistanceUnit new name: 'hectometer' factor: 1/100.
kilometer :=DistanceUnit new name: 'kilometer' factor: 1/1000.
! !

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:24'!
kilometer
^kilometer! !

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:30'!
meter
^meter ! !

!Units methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/16/2013 20:24'!
millimeter
^millimeter! !

TestCase subclass: #DistanceTest
	instanceVariableNames: 'oneMeter oneHundredCentimeters twoMeters twoHundredCentimeters units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/16/2013 17:45'!
centimeter
	
	^ units centimeter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/16/2013 17:45'!
decameter
	
	^units decameter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/16/2013 17:45'!
decimeter
	
	^ units decimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/17/2013 13:19'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	===============RESPUESTA=====================
	El metodo hace lo mismo que distanceUnits salvo que dentro de la categoria distance measures 
	con lo cual obtiene los mensajes que devuelven objetos de distancia.
	
	============================================
	
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/13/2013 14:29'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	
	===========================RESPUESTA=================================================
	el mtodo reflexiona sobre las categorias que pertenecen  a la clase cuyo selector es distanceUnits ( o sea DistanceTest)
	====================================================================================
	
	Por qu est hecho as? 
	
	============RESPUESTA============
	es la clase que tiene las categorias definidas
	===============================

	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?
	
	==========================RESPUESTA============================
	Asumiendo que se pregunta por distanceExamples los dos metodos son iguales.
	Se podria ingresar la categoria (distance units) directamente pero se pierde generalidad
	=============================================================
	
	======================OBSERVACION===============================

		Muy buenos ejercicios, sobre todo muy bien planteados!!
		Observacion: en los mismos no se termina de definir si la unidiad es necesaria.		
		                    
	=============================================================	
	"
	

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/16/2013 17:45'!
hectometer
	
	^ units hectometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/16/2013 17:44'!
kilometer
	
	^ units kilometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/16/2013 20:48'!
meter

	^ units meter.
	! !

!DistanceTest methodsFor: 'distance units' stamp: 'mercedesyManfredo 5/16/2013 17:46'!
millimeter
	
	^units millimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/17/2013 12:43'!
minusOneMeter 
	
	^Distance new magnitud: -1 unit:  units meter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/17/2013 13:23'!
oneCentimeter
	
	^Distance new magnitud: 1 unit: units centimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/9/2013 14:03'!
oneHundredCentimeters
	
	^oneHundredCentimeters! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/17/2013 19:53'!
oneMeter
	
^  Distance new magnitud: 1 unit: units  meter.! !

!DistanceTest methodsFor: 'as yet unclassified' stamp: 'mercedesyManfredo 5/17/2013 19:53'!
setUp 

	units := Units new.
	oneHundredCentimeters := Distance new.
	oneHundredCentimeters magnitud: 100.
	oneHundredCentimeters  unit: units  centimeter.
	twoHundredCentimeters := Distance new.
	twoHundredCentimeters magnitud: 200.
	twoHundredCentimeters  unit: units  centimeter.! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'mercedesyManfredo 5/13/2013 13:46'!
test01ObjectsRepresentingSameDistanceShouldBeEqual
  
	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'mercedesyManfredo 5/9/2013 17:36'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'mercedesyManfredo 5/16/2013 18:15'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util:
	=======================RESPUESTA====================================
	Se define el metodo equivalentTo: que decide si dos distancias de distintas unidades son iguales.
	
	self assert: (self twoMeters equivalentTo: twoHundredCentimeters ).
	
	======================FIN RESPUESTA ==================================

	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	========================RESPUESTA==================================
	evitar la pregunta por unit.
	
	============================FIN RESPUESTA================================================
	

	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	===========================RESPUESTA =================================================
		
	El convertTo convierte a distancia (amount y unit) , por lo que no tiene sentido preguntar por amount y luego unit
	
	===========================FIN RESPUESTA ===============================================
	
		
	"
	self assert: (self twoMeters equivalentTo: twoHundredCentimeters ).
	self assert: (oneHundredCentimeters  convertTo: self meter) = self oneMeter.
	(Array with: self oneHundredCentimeters   with: self oneMeter  )  do:[ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'mercedesyManfredo 5/13/2013 18:14'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?
	====================================RESPUESTA=======================
	representa un objeto generico
	
	
	"


	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'mercedesyManfredo 5/17/2013 12:57'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'mercedesyManfredo 5/17/2013 12:57'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/21/2011 17:24'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'mercedesyManfredo 5/17/2013 12:58'!
test21DistancesProvideATotalOrder

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'mercedesyManfredo 5/17/2013 12:58'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distanceExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'mercedesyManfredo 5/17/2013 12:58'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'mercedesyManfredo 5/17/2013 12:58'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'mercedesyManfredo 5/17/2013 18:20'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2)  by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:19'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'mercedesyManfredo 5/17/2013 20:38'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := self oneMeter  * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/9/2013 14:53'!
twoHundredCentimeters
	
	^twoHundredCentimeters ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/17/2013 18:53'!
twoMeters
	
	^ Distance new magnitud: 2 unit:units  meter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'mercedesyManfredo 5/17/2013 12:53'!
zeroMeters

	^Distance new magnitud: 0 unit: units meter.! !
